//*****************************************************************************
// Function definitions
//*****************************************************************************

static void Default_Handler(void);
// The following functions are declared with weak attributes.
// If another handler with the same name is presented it will be overridden.
void __attribute__ ((weak)) NMI_Handler(void);
void __attribute__ ((weak)) HardFault_Handler(void);
void __attribute__ ((weak)) SVC_Handler(void);
void __attribute__ ((weak)) PendSV_Handler(void);
void __attribute__ ((weak)) SysTick_Handler(void);
void __attribute__ ((weak)) WAKEUP_IRQHandler(void);
void __attribute__ ((weak)) SSP1_IRQHandler(void);
void __attribute__ ((weak)) I2C_IRQHandler(void);
void __attribute__ ((weak)) TIMER16_0_IRQHandler(void);
void __attribute__ ((weak)) TIMER16_1_IRQHandler(void);
void __attribute__ ((weak)) TIMER32_0_IRQHandler(void);
void __attribute__ ((weak)) TIMER32_1_IRQHandler(void);
void __attribute__ ((weak)) SSP0_IRQHandler(void);
void __attribute__ ((weak)) UART_IRQHandler(void);
void __attribute__ ((weak)) ADC_IRQHandler(void);
void __attribute__ ((weak)) WDT_IRQHandler(void);
void __attribute__ ((weak)) BOD_IRQHandler(void);
void __attribute__ ((weak)) PIOINT3_IRQHandler(void);
void __attribute__ ((weak)) PIOINT2_IRQHandler(void);
void __attribute__ ((weak)) PIOINT1_IRQHandler(void);
void __attribute__ ((weak)) PIOINT0_IRQHandler(void);
#pragma weak NMI_Handler = Default_Handler
#pragma weak HardFault_Handler = Default_Handler
#pragma weak SVC_Handler = Default_Handler
#pragma weak PendSV_Handler = Default_Handler
#pragma weak SysTick_Handler = Default_Handler
#pragma weak WAKEUP_IRQHandler = Default_Handler
#pragma weak SSP1_IRQHandler = Default_Handler
#pragma weak I2C_IRQHandler = Default_Handler
#pragma weak TIMER16_0_IRQHandler = Default_Handler
#pragma weak TIMER16_1_IRQHandler = Default_Handler
#pragma weak TIMER32_0_IRQHandler = Default_Handler
#pragma weak TIMER32_1_IRQHandler = Default_Handler
#pragma weak SSP0_IRQHandler = Default_Handler
#pragma weak UART_IRQHandler = Default_Handler
#pragma weak ADC_IRQHandler = Default_Handler
#pragma weak WDT_IRQHandler = Default_Handler
#pragma weak BOD_IRQHandler = Default_Handler
#pragma weak PIOINT3_IRQHandler = Default_Handler
#pragma weak PIOINT2_IRQHandler = Default_Handler
#pragma weak PIOINT1_IRQHandler = Default_Handler
#pragma weak PIOINT0_IRQHandler = Default_Handler

//*****************************************************************************
// Default handler
//*****************************************************************************
static void Default_Handler(void)
{
    while(1); // infinite loop
}

//*****************************************************************************
// Vector table
//*****************************************************************************
#pragma arm section rodata="RESET"

typedef void(* const ExecFuncPtr)(void) __irq;

//ExecFuncPtr exception_table[] = {
void (* const exception_table[])(void) = {
    /* (ExecFuncPtr)&Image$$ARM_LIB_STACK$$ZI$$Limit, */
          /* Initial SP, already provided by library */
    /* (ExecFuncPtr)&__main, */
          /* Initial PC, already provided by library */
    NMI_Handler,
    HardFault_Handler,
    0, 0, 0, 0, 0, 0, 0,    /* Reserved */
    SVC_Handler,
    0, 0,                   /* Reserved */
    PendSV_Handler,
    SysTick_Handler,
    /* Configurable interrupts start here...*/
    WAKEUP_IRQHandler,      /* 16+ 0: Wakeup PIO0.0 */
    WAKEUP_IRQHandler,      /* 16+ 1: Wakeup PIO0.1 */
    WAKEUP_IRQHandler,      /* 16+ 2: Wakeup PIO0.2 */
    WAKEUP_IRQHandler,      /* 16+ 3: Wakeup PIO0.3 */
    WAKEUP_IRQHandler,      /* 16+ 4: Wakeup PIO0.4 */
    WAKEUP_IRQHandler,      /* 16+ 5: Wakeup PIO0.5 */
    WAKEUP_IRQHandler,      /* 16+ 6: Wakeup PIO0.6 */
    WAKEUP_IRQHandler,      /* 16+ 7: Wakeup PIO0.7 */
    WAKEUP_IRQHandler,      /* 16+ 8: Wakeup PIO0.8 */
    WAKEUP_IRQHandler,      /* 16+ 9: Wakeup PIO0.9 */
    WAKEUP_IRQHandler,      /* 16+10: Wakeup PIO0.10 */
    WAKEUP_IRQHandler,      /* 16+11: Wakeup PIO0.11 */
    WAKEUP_IRQHandler,      /* 16+12: Wakeup PIO1.0 */
    0,                      /* 16+13: Reserved */
    SSP1_IRQHandler,        /* 16+14: SSP1 */
    I2C_IRQHandler,         /* 16+15: I2C */
    TIMER16_0_IRQHandler,   /* 16+16: 16-bit Counter-Timer 0 */
    TIMER16_1_IRQHandler,   /* 16+17: 16-bit Counter-Timer 1 */
    TIMER32_0_IRQHandler,   /* 16+18: 32-bit Counter-Timer 0 */
    TIMER32_1_IRQHandler,   /* 16+19: 32-bit Counter-Timer 1 */
    SSP0_IRQHandler,        /* 16+20: SSP0 */
    UART_IRQHandler,        /* 16+21: UART */
    0,                      /* 16+22: Reserved */
    0,                      /* 16+23: Reserved */
    ADC_IRQHandler,         /* 16+24: A/D Converter */
    WDT_IRQHandler,         /* 16+25: Watchdog Timer */
    BOD_IRQHandler,         /* 16+26: Brown Out Detect */
    0,                      /* 16+27: Reserved */
    PIOINT3_IRQHandler,     /* 16+28: PIO INT3 */
    PIOINT2_IRQHandler,     /* 16+29: PIO INT2 */
    PIOINT1_IRQHandler,     /* 16+30: PIO INT1 */
    PIOINT0_IRQHandler      /* 16+31: PIO INT0 */
};

#pragma arm section
