#include "MPS_CM0.h"

int main(void)
{
  SystemInit();

  // Program SysTick timer interrupt at 1KHz.
  // At 50MHz, SysTick trigger every 50000 CPU cycles
  SysTick_Config(50000);
  CPU_SYS->LED = 0x01; // Starting value

  while(1);
} // end main

// SysTick handler to toggle LED every 500 ticks
void SysTick_Handler(void)
{
  static short int TickCount = 0;
  if ((TickCount++) == 500) { // for every 500 counts, toggle LED
    TickCount = 0; // reset counter to 0
    if (CPU_SYS->LED==0x80) {
      CPU_SYS->LED = 0x01;
    } else {
      CPU_SYS->LED = CPU_SYS->LED << 1;
    }
  }
return;
}
