#include "LPC11XX.h"
#include <stdio.h>
#include "uart_io.h"

void UartPutHex(unsigned int din);

int main(void)
{
  unsigned int DataIn1, DataIn2;
  SystemInit();  // Switch Clock to 48MHz
  UartConfig();
  UartPuts("SVC demo\n");
  DataIn1 = 0x12;
  DataIn2 = 0x34;

  __asm (
   "    movs  r0,%0\n"
   "    movs  r1,%1\n"
   "    svc   0x3\n"
   :  : "r" (DataIn1), "r" (DataIn2) : "cc", "r0", "r1" );

  while(1);
} // end main

void SVC_Handler_c(unsigned int * svc_args)
{
  // Stack frame contains:
  // r0, r1, r2, r3, r12, r14, the return address and xPSR
  // - Stacked R0  = svc_args[0]
  // - Stacked R1  = svc_args[1]
  // - Stacked R2  = svc_args[2]
  // - Stacked R3  = svc_args[3]
  // - Stacked R12 = svc_args[4]
  // - Stacked LR  = svc_args[5]
  // - Stacked PC  = svc_args[6]
  // - Stacked xPSR= svc_args[7]

  unsigned int svc_number;
  svc_number = ((char *)svc_args[6])[-2];
  UartPuts("SVC Handler:\n");
  UartPuts("- R0 = 0x");
  UartPutHex(svc_args[0]);
  UartPutc('\n');

  UartPuts("- R1 = 0x");
  UartPutHex(svc_args[1]);
  UartPutc('\n');

  UartPuts("- SVC number = 0x");
  UartPutHex(svc_number);
  UartPutc('\n');

  return;
}

